
volatile int nbEncochesDr = 0;    // nombre d'encoches comptées par le capteur Droit
volatile int nbEncochesGa = 0;    // nombre d'encoches comptées par le capteur Gauche

void setup() {

  Serial.begin(115200);
  attachInterrupt(0,FrontCapteurDroit,CHANGE);    // ces interruptions servent a incrémenter ou décrementer la mesure du capteur
  attachInterrupt(1,FrontCapteurGauche,CHANGE) ;

}


unsigned long tMesurePrec=0;    // temps au moment du calcul de la position précédente
unsigned long tactuel=0;        // temps actuel
float Teta = 0;                 // position angulaire du robot
float MesureD = 0;              // valeur du compteur droit lors de la mesure précédente
float MesureG = 0;              // valeur du compteur droit lors de la mesure précédente
float PosX = 0;                 // position actuelle en x du robot
float PosY = 0;                 // position actuelle en y du robot


void loop(){

  tactuel = micros();                          // on regarde le temps
  if ((tactuel - tMesurePrec)>= 10000000) {    // si la dernière mesure de position remonte 
    calculPosition();                          // a plus de 1 milliseconde on relance une mesure
    tMesurePrec = tactuel;                     // on relève le temps auquel à été fait la mdernière mesure de position
  }

  if ((tactuel - tMesurePrec)>= 10000000) {
    Serial.print("Position X = ");
    Serial.println(PosX);
    Serial.print("Position Y = ");
    Serial.println(PosY);
    Serial.print("Position angulaire = ");
    Serial.println(Teta);
  }
}

void FrontCapteurDroit() 
{  // attention  l'ordre de detection defini le sens des roues

  uint8_t E4 = PINE & (1<<PE4);
  uint8_t G5 = PING & (1<<PG5);

  if (E4 ==0)                   
  { 
    if (G5 ==0) nbEncochesDr-- ;
    else nbEncochesDr++ ;
  }
  else
  {
    if (G5 ==0) nbEncochesDr++ ;
    else nbEncochesDr-- ;
  }
}

void FrontCapteurGauche() {                    

  uint8_t E3 = PINE & (1<<PE3);
  uint8_t E5 = PINE & (1<<PE5);

  if (E3 ==0)                   
  { 
    if (E5 ==0) nbEncochesGa-- ;
    else nbEncochesGa++ ;
  }
  else
  {
    if (E5 ==0) nbEncochesGa++ ;
    else nbEncochesGa-- ;
  }
}

void calculPosition() {      // Calcul de la position actuelle du robot
  float DeltaMoy = 0;
  float DeltaDif = 0;
  float DeltaPosX = 0;              // on réinitialise les valeurs
  float DeltaPosY = 0;
  float DeltaTeta = 0;
  float DistD = 0;                   // distance parcourue par la roue droite
  float DistG = 0;                   // distance parcourue par la roue gauche
  const float L = 233;               // largeur du robot en mm (entre les roues)


  DistD = nbEncochesDr*0.511;
  DistG = nbEncochesGa*0.511;
  
  Serial.print("nbEncochesDr = ");
  Serial.println(nbEncochesDr);
  Serial.print("nbEncochesGa = ");
  Serial.println(nbEncochesGa);
  
  nbEncochesDr=0;
  nbEncochesGa=0;
  DeltaMoy = (DistD + DistG)/2;
  DeltaDif =  DistG - DistD;
  DeltaTeta = DeltaDif/L;
  Teta = Teta + DeltaTeta;
  DeltaPosX = DeltaMoy*cos(Teta);
  DeltaPosY = DeltaMoy*sin(Teta);  
  PosX = PosX + DeltaPosX;
  PosY = PosY + DeltaPosY;

  Serial.print("DeltaMoy = ");
  Serial.println(DeltaMoy);
  Serial.print("DeltaDif = ");
  Serial.println(DeltaDif);
  Serial.print("DeltaTeta = ");
  Serial.println(DeltaTeta);
  Serial.print("DeltaPosX = ");
  Serial.println(DeltaPosX);
  Serial.print("DeltaPosY = ");
  Serial.println(DeltaPosY);


}







